local WEEK_SECONDS = 604800;

-- 2 = skittish
-- 3 = volcanic
-- 4 = necrotic
-- 5 = teeming
-- 6 = raging
-- 7 = bolstering
-- 8 = sanguine
-- 9 = tyrannical
-- 10 = fortified
-- 11 = bursting
-- 12 = grievous
-- 13 = explosive
-- 14 = quaking

-- Old schedule
--local WEEKLY_AFFIXES = {
--	{10,11,14},
--	{9,6,3},
--	{10,5,13},
--	{9,7,12},
--	{10,8,4},
--	{9,11,2},
--	{10,5,14},
--	{9,6,4},
--	{10,7,2},
--	{9,5,3},
--	{10,8,12},
--	{9,7,13}
--}

-- Season 3 schedule, maybe it'll hold for season 4...
local WEEKLY_AFFIXES = {
	{10,8,14},
	{9,7,13},
	{10,11,3},
	{9,6,4},
	{10,5,14},
	{9,11,2},
	{10,7,12}, 
	{9,6,13},
	{10,8,12},
	{9,5,3},
	{10,7,2},
	{9,11,4}
}

-------------------------------------------------------------------------------------
-- How many weeks long is the mythic+ affix schedule before it starts to repeat?
-------------------------------------------------------------------------------------
function KeystoneRollCall:GetWeekCount()
	return #WEEKLY_AFFIXES
end

-------------------------------------------------------------------------------------
-- What are the affixes for this week (plus offset)?
-------------------------------------------------------------------------------------
function KeystoneRollCall:GetWeeklyAffixes(offset)
	return unpack(WEEKLY_AFFIXES[KeystoneRollCall:GetWeeklyIndex(offset)])
end

-------------------------------------------------------------------------------------
-- How many weeks into the mythic+ affix schedule are we?
-------------------------------------------------------------------------------------
function KeystoneRollCall:GetWeeklyIndex(offset) 
	local weeklyIndex = (KCLib:GetWeeklyIndex() + (offset or 0)) % KeystoneRollCall:GetWeekCount()
	return weeklyIndex == 0 and KeystoneRollCall:GetWeekCount() or weeklyIndex
end

-------------------------------------------------------------------------------------
-- Get the month and day that a given week's keystone reset.
-------------------------------------------------------------------------------------
function KeystoneRollCall:GetStartDate(offset)
	local week = KCLib:GetWeeklyIndex() + (offset or 0)
	return date("%m/%d",week*WEEK_SECONDS+KCLib:GetLaunchTime())
end

-------------------------------------------------------------------------------------
-- Get the month and day that a given week's keystone reset.
-------------------------------------------------------------------------------------
function KeystoneRollCall:GetStartDateByWeek(week)
	return week and date("%m/%d", week * WEEK_SECONDS + KCLib:GetLaunchTime()) or ""
end

-------------------------------------------------------------------------------------
-- Get the week index in which the given time exists.
-------------------------------------------------------------------------------------
function KeystoneRollCall:GetWeekIndexByTime(time)
	return (math.floor((time - KCLib:GetLaunchTime())/ WEEK_SECONDS) + (offset or 0)) +6
end