local includeAlts, includeOffline, includeKeyless
local tab = {}
tab.index = 400;
tab.isKeyTable = true;
tab.text = KRCLocal:Get("tab_guild");
tab.value = "guild";
tab.propertyShowComplete = "guildShowComplete";
tab.propertyShowAlts = "guildShowAlts";
tab.propertyShowKeyless = "guildShowKeyless";
tab.propertyShowOffline = "guildShowOffline";
tab.propertyShowLeveling = "guildShowLeveling";
tab.propertyShowOpposingFaction = nil;
tab.showFilterResultsEditBox = true;

tab.populate = function()
	local playerKeystoneEntry = KCLib:GetPlayerKeystone();
	for i = 1, GetNumGuildMembers() do
		local fullName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR, reputation = GetGuildRosterInfo(i)
		local nameParts =  {strsplit("-",fullName)};

		KeystoneRollCall:SetCharacterField(fullName,"class",classFileName)
		KeystoneRollCall:SetCharacterField(fullName,"level",level)
		KeystoneRollCall:SetCharacterField(fullName,"realm",nameParts[2])
		KeystoneRollCall:SetCharacterField(fullName,"faction",playerKeystoneEntry.faction)

		local keystone = KeystoneRollCall:GetKeystoneEntry(fullName)
		if not keystone then
			keystone = {['name'] =fullName,['class'] = classFileName,keystoneDungeonId = 0,keystoneLevel = 0, ['faction'] = playerKeystoneEntry.faction,dummy=true}
		end
		KeystoneRollCall:AddListing(keystone,online);
	end
end

KeystoneRollCall.tabs[tab.value] = tab;